﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Mango.Controls.Menu
{
    public partial class MenuAccueil : UserControl
    {

        private ConnectionManager _connection = ConnectionManager.GetInstance();
        
        public MenuAccueil()
        {
            InitializeComponent();
        }

        private void MenuAccueil_Load(object sender, EventArgs e)
        {
            DataSet dataSet = _connection.DataSet;
            lblEvent.Text = "Il y a " + dataSet.Tables["Evenements"].Rows.Count + " événements";
            lblParticipant.Text = "Il y a " + dataSet.Tables["Participants"].Rows.Count + " participants";
            lblDepense.Text = "Il y a " + dataSet.Tables["Depenses"].Rows.Count + " dépenses";
            cboSelectEvent.DataSource = _connection.Filter("Evenements", "NOT soldeON");
            cboSelectEvent.DisplayMember = "titreEvent";
            cboSelectEvent.ValueMember = "codeEvent";
        }

        private void lblQuitter_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void btnContinuer_Click(object sender, EventArgs e)
        {
            FrmMain.GetInstance().ShowMenu(new MenuNouvelleDepense((int) cboSelectEvent.SelectedValue));
        }
    }
}
