﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Data.OleDb;

namespace Mango.Controls.Menu
{
    public partial class MenuRecapitulatif : UserControl
    {
        private ConnectionManager _connection = ConnectionManager.GetInstance();
        private int _eventId;
        private DataTable dtBilan = new DataTable();

        public MenuRecapitulatif(int eventId)
        {
            InitializeComponent();
            _eventId = eventId;
        }

        private void MenuRecapitulatif_Load(object sender, EventArgs e)
        {
            Cursor = Cursors.WaitCursor;

            lblEvenement.Text = "pour l'événement " + _connection.CreateCommand("select titreEvent from Evenements where codeEvent = " + _eventId).ExecuteScalar().ToString();
            dtBilan.Columns.Add("codeParticipant", typeof(int));
            dtBilan.Columns.Add("nomParticipant", typeof(string));
            dtBilan.Columns.Add("Plus", typeof(double));
            dtBilan.Columns.Add("Moins", typeof(double));
            dtBilan.Columns.Add("Solde", typeof(double));

            construireDtBilan();
            quiDoitQuoiAQui();
            genererLabels();

            PdfManager.GenererPdf(_eventId, "Evenement_" + _eventId);

            _connection.CreateCommand("update Evenements set soldeON = True where codeEvent = " + _eventId).ExecuteNonQuery();
            _connection.FetchOffline();

            Cursor = Cursors.Default;
        }

        private void quiDoitQuoiAQui()
        {
            bool fini = false;
            while (!fini)
            {
                DataRow donneur = dtBilan.Rows[0];
                DataRow receveur = dtBilan.Rows[0];

                for (int i = 0; i < dtBilan.Rows.Count; i++)
                {
                    if ((double)donneur["Solde"] > (double)dtBilan.Rows[i]["Solde"])
                    {
                        donneur = dtBilan.Rows[i];
                    }

                    if ((double)receveur["Solde"] < (double)dtBilan.Rows[i]["Solde"])
                    {
                        receveur = dtBilan.Rows[i];
                    }
                }

                if (Math.Round((double)donneur["Solde"]) == 0 && Math.Round((double)receveur["Solde"]) == 0)
                {
                    fini = true;
                }
                else
                {
                    if ((double)donneur["Solde"] * (-1) > (double)receveur["Solde"])
                    {
                        Dictionary<string, object> transaction = new Dictionary<string, object>();
                        transaction.Add("codeEvent", _eventId);
                        transaction.Add("codeDonneur", (int)donneur["codeParticipant"]);
                        transaction.Add("codeReceveur", (int)receveur["codeParticipant"]);
                        transaction.Add("montant", (double)receveur["Solde"]);

                        _connection.InsertInto("BilanPart", transaction);

                        double soldeMisA0 = (double)receveur["Solde"];

                        for (int i = 0; i < dtBilan.Rows.Count; i++)
                        {
                            if ((int)donneur["codeParticipant"] == (int)dtBilan.Rows[i]["codeParticipant"])
                            {
                                dtBilan.Rows[i]["Solde"] = (double)donneur["Solde"] + soldeMisA0;
                            }
                            else if ((int)receveur["codeParticipant"] == (int)dtBilan.Rows[i]["codeParticipant"])
                            {
                                dtBilan.Rows[i]["Solde"] = 0;
                            }
                        }
                    }
                    else if ((double)donneur["Solde"] * (-1) < (double)receveur["Solde"])
                    {
                        Dictionary<string, object> transaction = new Dictionary<string, object>();
                        transaction.Add("codeEvent", _eventId);
                        transaction.Add("codeDonneur", (int)donneur["codeParticipant"]);
                        transaction.Add("codeReceveur", (int)receveur["codeParticipant"]);
                        transaction.Add("montant", (double)donneur["Solde"] * (-1));

                        _connection.InsertInto("BilanPart", transaction);

                        double soldeMisA0 = (double)donneur["Solde"];

                        for (int i = 0; i < dtBilan.Rows.Count; i++)
                        {
                            if ((int)donneur["codeParticipant"] == (int)dtBilan.Rows[i]["codeParticipant"])
                            {
                                dtBilan.Rows[i]["Solde"] = 0;
                            }
                            else if ((int)receveur["codeParticipant"] == (int)dtBilan.Rows[i]["codeParticipant"])
                            {
                                dtBilan.Rows[i]["Solde"] = soldeMisA0 + (double)receveur["Solde"];
                            }
                        }
                    }
                    else // c'est égal
                    {
                        Dictionary<string, object> transaction = new Dictionary<string, object>();
                        transaction.Add("codeEvent", _eventId);
                        transaction.Add("codeDonneur", (int)donneur["codeParticipant"]);
                        transaction.Add("codeReceveur", (int)receveur["codeParticipant"]);
                        transaction.Add("montant", (double)donneur["Solde"] * (-1));

                        _connection.InsertInto("BilanPart", transaction);

                        for (int i = 0; i < dtBilan.Rows.Count; i++)
                        {
                            if ((int)donneur["codeParticipant"] == (int)dtBilan.Rows[i]["codeParticipant"])
                            {
                                dtBilan.Rows[i]["Solde"] = 0;
                            }
                            else if ((int)receveur["codeParticipant"] == (int)dtBilan.Rows[i]["codeParticipant"])
                            {
                                dtBilan.Rows[i]["Solde"] = 0;
                            }
                        }
                    }
                }
            }
        }

        private void construireDtBilan()
        {
            OleDbDataReader participants = _connection.CreateCommand("select p.codeParticipant, p.prenomPart + ' ' + p.nomPart from Participants p" +
                " left join Invites i on p.codeParticipant = i.codePart where i.codeEvent = " + _eventId).ExecuteReader();

            while (participants.Read())
            {
                DataRow nouvelleLigne = dtBilan.NewRow();
                double plus = depensesCredit((int)participants[0]);
                double moins = depensesDebit((int)participants[0]);

                nouvelleLigne["codeParticipant"] = (int)participants[0];
                nouvelleLigne["nomParticipant"] = participants[1].ToString();
                nouvelleLigne["Plus"] = plus;
                nouvelleLigne["Moins"] = moins;
                nouvelleLigne["Solde"] = plus - moins;

                dtBilan.Rows.Add(nouvelleLigne);
            }

        }

        private double depensesCredit(int idParticipant)
        {
            // Création de la commande de la procédure stockée.
            OleDbCommand commande = new OleDbCommand();
            commande.Connection = _connection.Connection;
            commande.CommandType = CommandType.StoredProcedure;
            commande.CommandText = "MesDepenses";

            // Paramètre pEvent
            OleDbParameter evenement = new OleDbParameter();
            evenement.ParameterName = "@pEvent";
            evenement.OleDbType = OleDbType.Integer;
            evenement.Direction = ParameterDirection.Input;
            evenement.Value = _eventId;
            commande.Parameters.Add(evenement);

            // Paramètre pPart
            OleDbParameter participant = new OleDbParameter();
            participant.ParameterName = "@pPart";
            participant.OleDbType = OleDbType.Integer;
            participant.Direction = ParameterDirection.Input;
            participant.Value = idParticipant;
            commande.Parameters.Add(participant);

            OleDbDataReader retour = commande.ExecuteReader();

            double somme = 0;

            while (retour.Read())
            {
                somme += double.Parse(retour[3].ToString());
            }

            return somme;
        }

        private double depensesDebit(int idParticipant)
        {
            // Création de la commande de la procédure stockée.
            OleDbCommand commande = new OleDbCommand();
            commande.Connection = _connection.Connection;
            commande.CommandType = CommandType.StoredProcedure;
            commande.CommandText = "DepensesQuiMeConcernent";

            // Paramètre pEvent
            OleDbParameter evenement = new OleDbParameter();
            evenement.ParameterName = "@pEvent";
            evenement.OleDbType = OleDbType.Integer;
            evenement.Direction = ParameterDirection.Input;
            evenement.Value = _eventId;
            commande.Parameters.Add(evenement);

            // Paramètre pPart
            OleDbParameter participant = new OleDbParameter();
            participant.ParameterName = "@pPart";
            participant.OleDbType = OleDbType.Integer;
            participant.Direction = ParameterDirection.Input;
            participant.Value = idParticipant;
            commande.Parameters.Add(participant);

            OleDbDataReader retour = commande.ExecuteReader();

            double somme = 0;

            int nbParts = (int)_connection.CreateCommand("select nbParts from Participants where codeParticipant = " + idParticipant).ExecuteScalar();

            while (retour.Read())
            {
                somme += Math.Round((double.Parse(retour[1].ToString())) * (nbParts*1.0 / int.Parse(retour[2].ToString())*1.0), 2);
            }

            return somme;
        }

        private void genererLabels()
        {
            OleDbDataReader participants = _connection.CreateCommand("select codeDonneur, codeReceveur, montant from BilanPart where codeEvent = " + _eventId).ExecuteReader();

            int i = 0;

            while (participants.Read())
            {
                Label remboursement = new Label();
                remboursement.AutoSize = false;
                remboursement.Size = new Size(761, 42);
                remboursement.Location = new Point(18, 133 + 56 * i);
                remboursement.Font = new Font("Bahnschrift", 11, GraphicsUnit.Point);

                string nomDonneur = _connection.CreateCommand("select prenomPart + ' ' + nomPart from Participants where codeParticipant = " +
                    (int)participants[0]).ExecuteScalar().ToString();
                string nomReceveur = _connection.CreateCommand("select prenomPart + ' ' + nomPart from Participants where codeParticipant = " +
                    (int)participants[1]).ExecuteScalar().ToString();

                remboursement.Text = nomDonneur + " doit " + participants[2] + "€ à " + nomReceveur;

                this.Controls.Add(remboursement);
                i++;
            }
        }

        private void btnRetour_Click(object sender, EventArgs e)
        {
            FrmMain.GetInstance().ShowMenu(new MenuBilan());
        }
    }
}
