﻿using System;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;

namespace Mango.Controls.Nav
{
    public partial class NavIcon : UserControl
    {

        #region Permet la configuration de l'icone dans le Designer
        
        [Category("Configuration"), Browsable(true), Description("Texte afficher dans l'icon")]
        public string Label
        {
            get => lblName.Text;
            set => lblName.Text = value;
        }

        [Category("Configuration"), Browsable(true), Description("Image afficher dans l'icon")]
        public Image Image
        {
            get => pctIcon.Image;
            set => pctIcon.Image = value;
        }

        [Category("Configuration"), Browsable(true), Description("Le menu associer")]
        public Menus Menu { get; set; }
        
        #endregion

        public new event EventHandler Click;
        
        public NavIcon()
        {
            InitializeComponent();
        }

        private void NavIcon_Load(object sender, EventArgs e)
        {
            foreach (Control control in Controls)
                control.Click += HandleClick;
        }

        /// <summary>
        /// Appelé lors du click sur un élément de l'icone
        /// </summary>
        private void HandleClick(object sender, EventArgs e)
        {
            Click?.Invoke(this, e); // Permet de lancer l'évenement Click de l'icone
        }
    }
}