﻿using System;
using System.Windows.Forms;
using Mango.Controls.Menu;

namespace Mango.Controls.Nav
{
    public partial class Navbar : UserControl
    {

        private readonly FrmMain _frmMain;

        public Navbar()
        {
            _frmMain = FrmMain.GetInstance();
            
            InitializeComponent();
        }


        private void Navbar_Load(object sender, EventArgs e)
        {
            foreach (Control control in Controls)
            {
                if (control is NavIcon icon)
                    icon.Click += HandleClick;
                    
            }
        }

        /// <summary>
        /// Appelé lors du click sur une icone
        /// </summary>
        private void HandleClick(object sender, EventArgs e)
        {
            if (!(sender is NavIcon icon)) return;
            
            switch (icon.Menu)
            {
                case Menus.Accueil:
                    _frmMain.ShowMenu(new MenuAccueil());
                    break;
                case Menus.Evenement:
                    _frmMain.ShowMenu(new MenuEvenement());
                    break;
                case Menus.Participants:
                    _frmMain.ShowMenu(new MenuParticipants());
                    break;
                case Menus.Depenses:
                    _frmMain.ShowMenu(new MenuDepenses());
                    break;
                case Menus.Bilan:
                    _frmMain.ShowMenu(new MenuBilan());
                    break;
            }
        }
    }
}
