﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Mango.Controls.Menu;

namespace Mango
{
    public partial class FrmMain : Form
    {

        private ConnectionManager _connection = ConnectionManager.GetInstance();

        public FrmMain()
        {
            _instance = this;
            _connection.FetchOffline();
            
            InitializeComponent();
        }

        /// <summary>
        /// Affiche le menu dans le formulaire
        /// </summary>
        /// <param name="menu">Le UserControl contenant le menu</param>
        public void ShowMenu(UserControl menu)
        {
            if (pnlMain.Controls.Count != 0)
            {
                Control old = pnlMain.Controls[0];
                pnlMain.Controls.Clear();
                old.Dispose();
            }
            
            pnlMain.Controls.Add(menu);
        }
        
        private void FrmMain_Load(object sender, EventArgs e)
        {
            MaximizeBox = false;
            ShowMenu(new MenuAccueil());
        }

        private static FrmMain _instance;

        public static FrmMain GetInstance()
        {
            return _instance;
        }
    }
}
