﻿using System;
using System.Net;
using System.Net.Mail;
using System.Text;
using System.Windows.Forms;
using Mango.Controls;
using Mango.Controls.Nav;

namespace Mango
{
    public class MailManager
    {

        private static string mail;
        private static string password;
        
        /// <summary>
        /// Envoie un mail
        /// </summary>
        /// <param name="address">Adresse du destinataire</param>
        /// <param name="obj">Objet du mail</param>
        public static void SendMail(string address, string obj)
        {
            if ((mail == null || password == null) && !SetCredentials()) return;

            string message = "Bonjour, \n\t Vous avez été invité.e à rejoindre un évenement Mango afin de participer à la bonne répartition des dépenses dans vos prochains voyages !\n\n\nL'équipe Mango";
            MailMessage msg;
            
            try
            {
                msg = new MailMessage(mail, address, obj, message);
            }
            catch (Exception)
            {
                MessageBox.Show("Email " + address + " invalide");
                return;
            }

            SmtpClient client = new SmtpClient();
            client.Port = 587;
            client.Host = "partage.unistra.fr";
            client.EnableSsl = true;
            client.Timeout = 10000;
            client.DeliveryMethod = SmtpDeliveryMethod.Network;
            client.Credentials = new NetworkCredential(mail, password);
            msg.Priority = MailPriority.Normal;
            msg.BodyEncoding = Encoding.UTF8;
            msg.DeliveryNotificationOptions = DeliveryNotificationOptions.OnFailure;
            try
            {
                client.Send(msg);
            }
            catch (Exception er)
            {
                MessageBox.Show(er.Message);
            }
        }

        /// <summary>
        /// Demande ses identifiants à l'utilisateur
        /// </summary>
        /// <returns>Si l'utilisateur a entré ses identifiants</returns>
        public static bool SetCredentials()
        {
            LoginForm login = new LoginForm();
            if(login.ShowDialog() != DialogResult.OK) return false;

            mail = login.Mail;
            password = login.Password;
            return true;
        }
    }
}